<?php
namespace Claromentis\Core\Event;

$GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"] ?: array()) + array("_f6ad69e5b7ae7662b1" . "d0fa05847ada65" => base64_decode("Y2xhcm9tZ" . "W50aXMvZn" . "JhbWV3b3J" . "r"), "_249e6410" . "75c6a2986" . "5e4c4b46d" . "959e7f" => base64_decode("dHJpZ2dlc" . "l9kZXByZW" . "NhdGlvbg=" . "="), "_c244a470df" . "52d1d5a7085" . "138ec94e393" => base64_decode("dW5zZXJpYWxp" . "emU="), "_9a9e2d14785bd" . "baecfc454cb009" . "e47a7" => base64_decode("MT" . "A="), "_d91a7be21d972d4aac861" . "a7352a2079f" => base64_decode("c2V0Tm" . "FtZQ=="), "_96be32a6f44bf54e635e" . "1736acf7a96c" => base64_decode("c2VyaWFs" . "aXpl"), "_6edacb78bd55c" . "5015af27c8ac1f" . "cd9af" => base64_decode("bWV0aG9kX2V4aXN0c" . "w=="), "_db6f0ba0791e9a635407659a9f" . "e04e40" => base64_decode("aXNfb" . "2JqZW" . "N0"), "_7cf327515b98333f2887781d" . "2582ce87" => base64_decode("TWV0aG9kIHNpZ25hdHVyZSBkZXByZWNhdGVkIGZvciB0aGUgRXZlbnREaXNwYXRjaGVyOjpkaXNwYXRjaCgpIHNpbmNlIENvcmUgMTAsIGR1ZSB0byBTeW1mb255IDUncyBjaGFuZ2VzOiBzd2FwIHRoZSBmaXJzdCB0d28gYXJndW1lbnRzIHRvIHR" . "oaXMgbWV0aG9k"));
use Claromentis\Common\ApplicationMiscellany\Finisher;
use Claromentis\Core\Services;
use Symfony\Contracts\EventDispatcher\Event;
use Symfony\Component\EventDispatcher\EventDispatcher as BaseEventDispatcher;




class EventDispatcher extends BaseEventDispatcher implements EventDispatcherInterface
{
    
    
    
    
    
    
    protected ?Finisher $finisher;
    
    
    
    
    public function __construct(Finisher $_fea16585ee8de2b835a68ccd4bc60aef = null)
    {
        parent::__construct();
        $this->finisher = $_fea16585ee8de2b835a68ccd4bc60aef;
    }
    
    
    
    
    
    
    
    
    public static function Shared()
    {
        return Services::I()->dispatcher;
    }
    
    
    
    
    
    
    
    
    
    
    
    public function dispatch($event, $_2cf093f28f4c7e718a5e8af628894c7b = null, bool $_46d17db0bd1ac920366ce3e210c240c1 = false) : object
    {
        if ($GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_db6f0ba0791e9a635407659" . "a9fe04e40"]($event)) {
            return $this->bcAwareDispatch($event, $_2cf093f28f4c7e718a5e8af628894c7b, $_46d17db0bd1ac920366ce3e210c240c1);
        }
        $GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_249e641075c6a29865e4c4b46d959e" . "7f"]($GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_f6ad69e5b7ae7662b1d0fa05847" . "ada65"], $GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_9a9e2d14785bdbaecfc454cb0" . "09e47a7"], $GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_7cf327515b" . "98333f28877" . "81d2582ce87"]);
        return $this->bcAwareDispatch($_2cf093f28f4c7e718a5e8af628894c7b, $event, $_46d17db0bd1ac920366ce3e210c240c1);
    }
    
    
    
    
    
    
    
    
    
    private function bcAwareDispatch(object $event = null, ?string $_2cf093f28f4c7e718a5e8af628894c7b, bool $_46d17db0bd1ac920366ce3e210c240c1 = false) : object
    {
        if ($event === null) {
            $event = new Event();
        }
        if ($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_6edacb78bd55c5015" . "af27c8ac1fcd9af"]($event, $GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_d91a7be21d972d4" . "aac861a7352a2079" . "f"])) {
            $event->setName($_2cf093f28f4c7e718a5e8af628894c7b);
        }
        if (!$_46d17db0bd1ac920366ce3e210c240c1 || !isset($this->finisher)) {
            return parent::dispatch($event, $_2cf093f28f4c7e718a5e8af628894c7b);
        } else {
            $_a6a149597bf68ad5294d98abc0bda72b = $GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_96be32a" . "6f44bf54" . "e635e173" . "6acf7a96" . "c"]($event);
            $this->finisher->FinishHim(function ($request, $_fd5a3a643834299cbdadfc3540ba0bcb) use($_2cf093f28f4c7e718a5e8af628894c7b, $_a6a149597bf68ad5294d98abc0bda72b) {
                $event = $GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_c244a470df52d1d5a708" . "5138ec94e393"]($_a6a149597bf68ad5294d98abc0bda72b);
                $this->dispatch($event, $_2cf093f28f4c7e718a5e8af628894c7b, false);
            });
            return $event;
        }
    }
}